      subroutine th_timewindows(isubthe,icase,iput,iget,info) 
     use glbconst, only: icstrf,ivstrf
     use comthe, only: array_fr,theoryname
     implicit none 
     integer, intent(inout):: isubthe
     integer, intent(in):: icase,iput,iget       
     integer, intent(out),optional :: info
     
     real          Tbunch
     integer       ibn,ien
     common/strLOC/ibn(18),Tbunch,ien(13)  
     real          c1,an_strob_order,                                  &
                   t1_window,t2_window,am_window,dumc
     common/acmaps/c1,an_strob_order,am_window,                        &
                   t1_window,t2_window,dumc(icstrf-5)
     logical       b_c1,b_strob_order,b_amwindow,                      &
                   b_t1_window,b_t2_window,b_dumc      
     common/bcmaps/b_c1,b_strob_order,b_amwindow,                      &
                   b_t1_window,b_t2_window,b_dumc(icstrf-5)

     real          v1,va12,vb12,dumv 
     common/avmaps/v1,va12,vb12,dumv(ivstrf-3) 
     logical       b_v1,b_va12,b_vb12,b_dumv 
     common/bvmaps/b_v1,b_va12,b_vb12,b_dumv(ivstrf-3) 

     integer iStrobo,jStrobo,jjStrobo,nStrobo,mStrobo,mWin 
     real    T2pT1,T2mT1,T2pT12,T2mT12,eta
     complex swin,swinp,swinm,swin1,swin10,swin2,swin2p,swin2m,swin20 

     real,    parameter:: pi=atan(1.0)*4.0 
     complex, parameter:: hci=cmplx(0.,1.)                           
                                                                        
                                                                        
!      write(6,'(a,4i6,a)')'th_timewindows isubthe,icase,iput,iget=',   
!     &                isubthe,icase,iput,iget                          
                                                                        
      if(isubthe.lt.0) then 
       if(icase.eq.1)c1=an_strob_order*2+1 
       if(icase.eq.2)then
        c1=an_strob_order*am_window*3+4 
        if(am_window.eq.0.)c1=an_strob_order*3+4 
       end if
!      storage for this routine                                         
       theoryname='rectangular_time_windows      v=200' 
       return 
      end if 
!      write(6,'(a,4i6,l5)')'th_timewindows isubthe,icase,iput,iget,b_c1=', &  
!                                          isubthe,icase,iput,iget,b_c1

       if(.not.b_c1) then 
        isubthe=-abs(isubthe) 
        return 
       end if 
       info=0                                                                 
                                                                          
      if(iget.eq.0) print'(a)','iget not defined'      

      if(icase.eq.1) then 
!      array_sp(iput+1)=s1                                              
!      Calculation of the diskret frequencies                           
!      Omega = 2.D0*PI/Tbunch                                           
!      VOmega= Omega*h/E0*C/2.D0/PI          ! Omega in mm/s            

       T2pT1 = (t2_window+t1_window)*pi 
       T2mT1 = (t2_window-t1_window)*pi 
                                                                        
       swin=cmplx(T2mT1,0.0)/pi 
       array_fr(iput+1)=swin 

       nStrobo=an_strob_order 
       do iStrobo=1,nStrobo 
         swin  = exp(hci*float(iStrobo)*T2pT1)/pi                  &
                 *sin(float(iStrobo)*T2mT1)/float(iStrobo)
!        write(6,'(I4,2F10.3)')iStrobo,swin                                    
        array_fr(iput+1+iStrobo)=swin 
       end do
       array_fr(iput+1)=array_fr(iput+1)/2.

      else if (icase.eq.2) then                                        
       t1_window=t1_window/Tbunch
       t2_window=t2_window/Tbunch 

!     number of boxcar funtions inside Tbunch:
      mWin    = am_window
      if(mWin.eq.0) then
       mStrobo=0; mWin=1; nStrobo=an_strob_order 

      else
       mStrobo =an_strob_order    ! max Fourier component considered in case 
                                  ! of the second window
      nStrobo=an_strob_order*mWin       
      end if
      eta     = 1./float(6*mWin) !shift for real and imaginay parts

      swin20  = (0.5,0.0)  !zeroth Fourier component of the 2nd window
                           ! for the first timewindow t1-t2 (defined by veto)
       T2pT1 = (t2_window+t1_window)*pi 
       T2mT1 = (t2_window-t1_window)*pi 
            ! for the second timewindow repeted mWin times duaring [0,Tbunch]
       T2pT12 = (0.75+0.25)*pi/mWin ! =(t2_window2+t1_window2)*pi/mWin 
       T2mT12 = (0.75-0.25)*pi/mWin ! =(t2_window2-t1_window2)*pi/mWin 
                                                                        
       swin10=cmplx(T2mT1,0.0)/pi 
                                                                       
       do iStrobo=0,nStrobo 
        swin =(0.0,0.0) 
        swinp=(0.0,0.0) 
        swinm=(0.0,0.0) 
!        swin1 = (1.0,0.0)
        do jStrobo = -mStrobo,mStrobo
         jjStrobo = mWin*jStrobo
         if(iStrobo-jjStrobo.eq.0)then
          swin1 = swin10
!         swin1 = (1.0,0.0)
         else
          swin1 = exp(-hci*float(iStrobo-jjStrobo)*T2pT1)/pi    &
                  *sin(float(iStrobo-jjStrobo)*T2mT1)/float(iStrobo-jjStrobo)
         endif                         

         if(jjStrobo.eq.0)then
          swin2 = swin20
         else
          swin2 = mWin*exp(-hci*float(jjStrobo)*T2pT12)/pi    &
                  *sin(float(jjStrobo)*T2mT12)/float(jjStrobo)        
         endif
         swin2p= swin2*exp(-hci*2.*pi*float(jjStrobo)*eta)
         swin2m= swin2*exp( hci*2.*pi*float(jjStrobo)*eta)
         swin  = swin+swin1*swin2
         swinp = swinp+swin1*swin2p
         swinm = swinm+swin1*swin2m
        end do
!        write(6,'(I4,6F10.3)')iStrobo,swin,swinp,swinm
!        write(6,'(I4,4F10.3)')iStrobo,swin,swinp   
        array_fr(iput+1+iStrobo)=swin 
        array_fr(iput+2+nStrobo+iStrobo)=swinp 
        array_fr(iput+3+2*nStrobo+iStrobo)=swinm 
!         array_fr(iput+1+nStrobo-i)=conjg(swin)                          
       end do 
       array_fr(iput+1)          =array_fr(iput+1)/2. 
       array_fr(iput+2+nStrobo)  =array_fr(iput+2+nStrobo)/2.
       array_fr(iput+3+2*nStrobo)=array_fr(iput+3+2*nStrobo)/2.
      end if 
                                                                        
      return 
!    End of calculation of the diskret frequencies                      
!                                                                       
      END                                           
                                                                        
                                                                        
     subroutine th_sampleorient(isubthe,icase,iput,iget,info) 
     use glbconst, only: icstrf,ivstrf,infotext,enwr
     use comthe, only: array_fr,theoryname
     implicit none 
                                                                       
     integer, intent(inout):: isubthe
     integer, intent(in):: icase,iput,iget       
     integer, intent(out),optional :: info

     real          c1,dumc 
     common/acmaps/c1,dumc(icstrf-1) 
                                                                       
     real          v1,phi,theta,psi,ax_theta,ax_phi,omega,             &
                   x_theta,x_phi,z_theta,z_phi,dumv                    
     common/avmaps/v1,phi,theta,psi,ax_theta,ax_phi,omega,             &
                   x_theta,x_phi,z_theta,z_phi,dumv(ivstrf-11)         
     logical       b_v1,b_phi,b_theta,b_psi,b_axtheta,b_axphi,b_omega, &
                   b_xtheta,b_xphi,b_ztheta,b_zphi,b_dumv              
     common/bvmaps/b_v1,b_phi,b_theta,b_psi,b_axtheta,b_axphi,b_omega, &
                   b_xtheta,b_xphi,b_ztheta,b_zphi,b_dumv(ivstrf-11)   
                                                                       
     real,   parameter::pi=3.141592654,rad=0.017453293
     complex,parameter::hc0=(0.0,0.0) 
     real    alpha,beta,gamma,thickness 
     logical b_change,b_pc 
                                                                        
                                                                        
                                                                        
      if(isubthe.lt.0) then 
       c1=4 
!      storage for this routine                                         
       theoryname='sample_orientation' 
       return 
      end if 
!     write(6,'(a,i2)')' enter sample_orientation icase=',icase        
!     write(6,'(a,3f10.1)')' phi,theta,psi=',phi,theta,psi        
      info=0                                                                       
      if(icase.eq.1) then 
        array_fr(iput+2)=hc0                  !  alpha,     false       
        array_fr(iput+3)=hc0                  !  beta,      not used    
        array_fr(iput+4)=hc0                  !  gamma,     not used    
        array_fr(iput+1)=cmplx(1.0,1.0)       !  thickness, not used    
        isubthe=-abs(isubthe)                 ! no change of input      
       return 
      end if 

      if(iget.eq.0) print'(a)','iget not defined'      
                                                                        
!       write(6,'(a,i2,i8,10f8.2)')                          &                                  
!        'icase,iput,phi,theta,psi,ax_theta,ax_phi,omega=',  &          
!         icase,iput,phi,theta,psi,ax_theta,ax_phi,omega               
!      write(6,'(10f12.2)')d_x2 ,x2_eta,x2_phi,x2_theta,x2_psi          
      b_pc=.false. 
      if(icase.eq.2.or.icase.eq.3) then 
       b_change=b_phi.or.b_theta.or.b_psi.or.                           &
     &                b_axtheta.or.b_axphi.or.b_omega                   
       if(b_change) then 
        b_pc=.true. 

        call euler_omega(ax_theta,ax_phi,omega,phi,theta,psi,           &
                  alpha,beta,gamma,thickness,icase,enwr,infotext,info)        

        if(info.gt.0) return 
!        write(6,'(a,g10.4,i3)')' thickness=',thickness,icase           
        if(icase.eq.2) then 
         array_fr(iput+1)=cmplx(1.0,2.0) 
        else 
         array_fr(iput+1)=cmplx(thickness,float(icase)) 
        end if 
!       write(6,'(a,i2,i8,/,10f12.2)')  &                                
!        'icase,iput,ax_theta,ax_phi,omega,alpha,beta,gamma=',&         
!         icase,iput,ax_theta,ax_phi,omega,alpha,beta,gamma            
!       write(6,'(a,10f8.2)')  &                                         
!         'omega,alpha,beta,gamma=',omega,alpha,beta,gamma             
        array_fr(iput+2)=cmplx(alpha,1.0) 
        array_fr(iput+3)=cmplx(beta,1.0) 
        array_fr(iput+4)=cmplx(gamma,1.0) 
       else 
        alpha=real(array_fr(iput+2)) 
        array_fr(iput+2)=cmplx(alpha,0.0) 
        isubthe=-abs(isubthe) 
       end if 
      else if(icase.gt.3) then 
       b_change=b_xtheta.or.b_xphi.or.b_ztheta.or.b_zphi 
       if(b_change) then 
!       x,z unit vectors of the sample in the lab system                
        b_pc=.true. 
                                                                        
        call euler_dir(x_theta,x_phi,z_theta,z_phi,                     &
     &                      alpha,beta,gamma,thickness,enwr,info)            
        if(info.gt.0) return 
        if(icase.eq.4) then 
         array_fr(iput+1)=cmplx(1.0,4.0) 
        else 
         array_fr(iput+1)=cmplx(thickness,float(icase)) 
        end if 
        array_fr(iput+2)=cmplx(alpha,1.0) 
        array_fr(iput+3)=cmplx(beta,1.0) 
        array_fr(iput+4)=cmplx(gamma,1.0) 
       else 
        alpha=real(array_fr(iput+2)) 
        array_fr(iput+2)=cmplx(alpha,0.0) 
        isubthe=-abs(isubthe) 
       end if 
      end if 
      return 
      END                                           


     subroutine th_debye(isubthe,icase,iput,iget,info) 
     use glbconst, only: icstrf,ivstrf
     use comthe, only: array_fr,theoryname
     implicit none 
                                                                       
     integer, intent(inout):: isubthe
     integer, intent(in):: icase,iput,iget       
     integer, intent(out),optional :: info

     real          c1,dumc 
     common/acmaps/c1,dumc(icstrf-1) 
                                                                       
     real          v1,phi,theta,psi,ax_theta,ax_phi,omega,             &
                   x_theta,x_phi,z_theta,z_phi,dumv                    
     common/avmaps/v1,phi,theta,psi,ax_theta,ax_phi,omega,             &
                   x_theta,x_phi,z_theta,z_phi,dumv(ivstrf-11)         
     logical       b_v1,b_phi,b_theta,b_psi,b_axtheta,b_axphi,b_omega, &
                   b_xtheta,b_xphi,b_ztheta,b_zphi,b_dumv              
     common/bvmaps/b_v1,b_phi,b_theta,b_psi,b_axtheta,b_axphi,b_omega, &
                   b_xtheta,b_xphi,b_ztheta,b_zphi,b_dumv(ivstrf-11)   
                                                                       
     real,   parameter::pi=3.141592654,rad=0.017453293
     complex,parameter::hc0=(0.0,0.0) 
                                                                        
!planed                                                                         
                                                                        
     if(isubthe.lt.0) then
       theoryname='f_is_debye      v=001' 
       if(isubthe.eq.-16) return        
       c1=4 
!      storage for this routine                                         
       return 
      end if 
!     write(6,'(a,i2)')' enter debye icase=',icase        

      if(iget.eq.0) print'(a)','iget not defined'      
                                                                        
!      write(6,'(a,i2,i8,10f8.2)')'icase,iput,var debey,const tem=',  &          
!           icase,iput,omega,dumc(6)
      array_fr(iput+1)=omega*2;array_fr(iput+2)=dumc(6)*2 
      return 
      END                                           

