      PROGRAM LINESA 
!                                                                       
!	INDEXES IRON SPECTRA OF MAGNETIC SPLITTING                            
!                                                                       
!	H.VOGEL     1975                                                      
!       E.MEISSNER  10.11.81                                            
!	MODIFIED FOR FORMAT FREE INPUT                                        
!       PAUSE STATEMENT REMOVED   M. ALFLEN 28.10.88
!       h. Spiering  1998 (-> xalpl)
                    
      implicit none
     integer,parameter :: maxco=64
     character(len=4)  :: enwr(16)                                                                        
     character(len=132):: queryar,helpar,type,deffile,filetype,       &
                          querytype,chin,chcom,ch132,cp132,chstart
     character(len=16) :: ext,winfile,ch16
     character(len=80) :: ch80,localhepath
     character(len=3),dimension(1:3):: eai,ebi
      integer           ld,lw,laenge,lpart
      common/localpath/ localhepath 
      common/scrd/ queryar(maxco),helpar(maxco),ext(maxco),type(maxco),&
                   ld(maxco),lw(maxco),laenge(maxco),lpart(0:maxco)

      real      out(32),uveca(3,3),uvecb(3,3),uvec(3),                 &
                uvec1(3),uvec2(3),uvec3(3),dj(-4:4,-4:4),hi,           &
                AX(5,5),VX(5,5),DV(5),bx(3,3)

      real      arcos,ax_theta,ax_phi,                                 &
                omega,oalpha,obeta,ogamma,omx,omy,omz                
      complex   hc,dsxct,t2m,v1m,t2mC,hc1,dclv,v1mL,dj1,dj2,drt 
      dimension dsxct(-4:4,-4:4),t2m(-2:2),t2mC(-2:2),                  &
                v1m(-1:1),v1mL(-1:1),dclv(-1:1,-1:1),                   &
                dj1(-1:1,-1:1),dj2(-1:1,-1:1),drt(-1:1,-1:1)

      real     P(8),A,aL,aR,XM,YM,xbeg,ybeg,QU,ANL,rad,xend,yend,       &
               XO,XU,X,DX
      integer  N1,N2
      common/LINE/ A(8,201),N1,N2,aL,aR,XM,YM,xbeg,ybeg
      character(len=80),dimension(1:30):: text
      character(len=36):: format
      LOGICAL   OK,BEG,b_file 
      character ch1*1,ch2*2,yn*1   

      integer   ncl,nwr,nrd,kwin,icol,i,jj,k,km,N,j,l,nn,            &
                id1,npl,ncol,nrows,ixpixel,iypixel,led  
      common/term/id1,npl,ncol(8),nrows(8),ixpixel(8),iypixel(8),       &
                  winfile,led       
                                                                     ! c
                                                                        
                                                                        
        localhepath='/Mossbauer_spectrum.help' 
      chstart='L=-6.5509 R=5.8341  Is=-0.5 Deq=-4.0'                                                                         
   17 BEG = .TRUE. 
      WRITE (6,100) 
  100 FORMAT(1H ,'PROGRAM LINESA -  19.11.80',/,                        &
     &         1H ,'FOR INDEXING MAGNETIC SPLITTED IRON SPECTRA',/)     
                                                                        
       open(unit=2,file='lines.dat'                                     &
     &            ,status='unknown'                                     &
     &            ,access='sequential'                                  &
     &            ,form='formatted')                                    
        open(unit=3,file='lines.txt'                                    &
     &            ,status='unknown'                                     &
     &            ,access='sequential'                                  &

     &            ,form='formatted')                                    
      ncl=80 
      nwr=6 
      nrd=5 
      kwin=1 
      call window(kwin) 
      npl=ncol(kwin) 
      icol=npl 
      rad=atan(1.)/45. 
                                                                        
   29 querytype='line position L1,L6, shift IS,and  Deq:' 
      chcom='read/positionLR' 
      call askstring(querytype,chstart,chcom,ncl,nrd,nwr) 
      ch1=chstart(1:1) 
      if(ch1.eq.'*'.or.ch1.eq.'q') goto 1000 
                                                                        
      call trlch(80,chstart,nn,out) 
      if(nn.ne.4)then 
       write(nwr,'(a)') ' 4 numbers are expected' 
       goto 29 
      end if 
      aL=out(1) 
      aR=out(2) 
      ANL=out(3) 
      QU=out(4) 
      ch16='(a2,f6.2,a3,f5.2' 
      if(ANL.ge.0.and.QU.ge.0.)format=ch16//',a4,f5.2,a5,f5.2)' 
      if(ANL.lt.0.and.QU.ge.0.)format=ch16//',a4,f6.2,a5,f5.2)' 
      if(ANL.ge.0.and.QU.lt.0.)format=ch16//',a4,f5.2,a5,f6.2)' 
      if(ANL.lt.0.and.QU.lt.0.)format=ch16//',a4,f6.2,a5,f6.2)' 
      xbeg=aL 
      xend=aR 
                                                                        
      aL = (aL-ANL)*2./abs(QU) 
      aR = (aR-ANL)*2./abs(QU) 
                                                                        
      IF (aL.GE.aR) GOTO 27 
!     batfile of the spectrum                                           
      querytype=                                                        &
     &  'read bat file of the spectrum associated to the line positions'
       ch1='y' 
       chcom='batfile' 
       call yesno(querytype,ch1,chcom,npl,nrd,nwr) 
       if(ch1.eq.'n') then 
        write(2,format)'L=',xbeg,' R=',xend,' IS=',ANL,' Deq=',QU 
        write(2,'(a)') 'mm/s' 
        write(2,'(a)') '\\g' 
        write(2,'(a,2f10.2)')'34  ', xbeg-1., 0. 
        write(2,'(a,2f10.2)')'34  ', xend+1., 1.01 
        ybeg=0. 
        yend=1.0 
        XM=xend-xbeg 
        YM=yend-ybeg 
       else 
  101   filetype='allplo .bat file for the spectrum' 
        deffile='spectrum.bat' 
        ext='bat' 
        chcom='batfile' 
        call  readfile(filetype,deffile,ext,ld,chcom,ncl,nrd,nwr) 
        if(deffile(1:1).eq.'q') goto 1000 
        inquire(file=deffile,exist=b_file) 
        if(b_file) then 
         open (unit=12,file=deffile                                     &
     &                    ,status='old'                                 &
     &                    ,access='sequential'                          &
     &                    ,form='formatted')                            
         jj=0 
         do i=1,30 
          read(12,'(a)',end=102)text(i) 
          write(6,'(a)')text(i) 
          if(index(text(i)(:10),'more').gt.0) then 
           k=index(text(i),'[n]') 
           km=k 
           text(i)(k+1:k+1)='y' 
          end if 
          if(index(text(i),'Both,left').gt.0)then 
           k=index(text(i),'[') 
            text(i)(k+1:k+1)='l' 
          end if 
          jj=jj+1 
         end do 
                                                                        
  102  close(unit=12) 
                                                                        
  103    filetype='allplo .bat file for lines' 
         deffile='lines.bat' 
         ext='bat' 
         chcom='batfile/lines' 
         call  readfile(filetype,deffile,ext,ld,chcom,ncl,nrd,nwr) 
         if(deffile(1:1).eq.'q') goto 1000 
         open (unit=12,file=deffile                                     &
     &                    ,status='unknown'                             &
     &                    ,access='sequential'                          &
     &                    ,form='formatted')                            
                                                                        
         do i=1,jj 
          write(12,'(a)')text(i) 
         end do 
                                                                        
         i=0 
         do while(i.lt.jj) 
          i=i+1 
           if(index(text(i),'Both,bottom').gt.0)then 
            k=index(text(i),'[') 
            text(i)(k+1:k+1)='n' 
           end if 
           if(index(text(i),'Both,left').gt.0)then 
            k=index(text(i),'[') 
            text(i)(k+1:k+1)='n' 
           end if 
           if(index(text(i),'y-range').gt.0)then 
            k=index(text(i),'[') 
            text(i)(k+1:)='0.,1.0]     (log scale y/n) [n]' 
            text(i+1)='    scale(l,r,step,tics,pw) [0.  1.00  0.2  2 0]' 
            text(i+5)=                                                  &
     &      '    inscription          (normal,left,right,inverted)  [n]'
            ybeg=0 
            yend=0.97 
           end if 
           k=index(text(i),'background') 
           if(k.gt.0)text(i)(k+12:)=' []            ' 
           k=index(text(i),'file=') 
           if(k.gt.0)text(i)(k+5:)=' [lines.txt]' 
           k=index(text(i),'file name') 
           if(k.gt.0) then 
            text(i)(k+10:)='[lines.dat]' 
            l=index(text(i+1),'file name') 
            if(l.gt.0) then 
             do j=i+1,jj-1 
              text(j)=text(j+1) 
             end do 
             jj=jj-1 
            end if 
           end if 
!           k=index(text(i),'name of y-axis')                           
!           if(k.gt.0) then                                             
!            k=index(text(i),'[')                                       
!            text(i)(k:)='[\\gc]'                                       
!           end if                                                      
           k=index(text(i),'structure') 
           if(k.gt.0)then 
            k=index(text(i),'[') 
            text(i)(k+1:)='allplo]' 
           end if 
          end do 
                                                                        
          text(jj)(km+1:km+1)='n' 
          do i=1,jj 
           write(12,'(a)')text(i) 
           write(6,'(a)')text(i) 
          end do 
          write(2,format)'L=',xbeg,' R=',xend,' IS=',ANL,' Deq=',QU 
          write(2,'(a)') 'mm/s' 
          write(2,'(a)') '\\g' 
          XM=xend-xbeg 
          YM=yend-ybeg 
        else 
        goto 101 
        end if  ! no spectrum.bat file 
       end if 
                                                                        
                                                                        
      GOTO 25 
   27 WRITE (6,28) 
   28 FORMAT (11H  BAD INPUT) 
      GOTO 29 
   30 WRITE (6,28) 
      GOTO 29 
   25 N = 1 
        XO=-(aR+aL)/2. 
      IF (aL.LT.-aR) GO TO 4 
      XU = aL 
      GO TO 9 
    4 XU = -(aL+2.*aR) 
    9 DX= (XO-XU)/100. 
      X = XU
!      write(6,'(a,3f10.2)')' Xu,XO,DX=',XU,XO,DX                     
    6 CALL INDIZIER (aL,aR,X,P,QU,OK) 
      IF (BEG.AND.OK) N1 = N 
      IF (OK) BEG = .FALSE. 
      IF (.NOT.OK.AND..NOT.BEG) GOTO 5 
      A(1,N) = P(1) 
      A(2,N) = P(2) 
      A(3,N) = P(3) 
      A(4,N) = P(4) 
      A(5,N) = P(5) 
      A(6,N) = P(6) 
      A(7,N) = P(7) 
      A(8,N) = P(8) 
      N = N+1 
      X = X+DX 
      IF (N.GT.101.AND.BEG) GOTO 11 
      IF (N.GT.101) GOTO 12 
      GOTO 6 
    5 N = N-1 
      N2 = N 
      WRITE(6,777) N1,N2 
  777 FORMAT('  VARIATIONSBEREICH: N1, N2 = ',2I4/) 
                                                                        
      CALL PLOT3 
      GOTO 7 
   11 WRITE (6,13) 
   13 FORMAT (13H  NO SOLUTION) 
    7 GOTO 1000 
!       WRITE (6,18)                                                    
   18 FORMAT (20H  FURTHER PARAMETERS) 
   19 WRITE (6,'(a)')'TYPE y/n)' 
      READ (5,'(a1)') yn 
      IF (yn.EQ.'y') GOTO 17 
      IF (yn.NE.'n') GOTO 19 
      GOTO 1000 
   12 WRITE (6,14) 
   14 FORMAT (26H  SOLUTION IS NOT COMPLETE) 
      GOTO 5 
1000  CONTINUE
      
        close(unit=2) 
        close(unit=3)
        close(unit=12)
        goto 17
      STOP 
    END PROGRAM LINESA
!                                                                       
!                                                                       
      SUBROUTINE INDIZIER(L,R,X,P,QU,OK) 
!                                                                       
!	INDEXES IRON SPECTRA OF MAGNETIC SPLITTING.                           
!	(CALLED BY PROGRAM LINES.)                                            
!	L AND R ARE THE POSITIONS OF THE OUTERMOST LINES                      
!	ON THE LEFT AND RIGHT SIDE, RESPECTIVELY.                             
!	X IS THE POSITION OF THE SECOND LINE FROM THE LEFT.                   
!	P(1), ... P(8) ARE THE EIGHT LINE-POSITIONS.                          
!	OK = .TRUE. IF THE LAST ONE SOLUTION EXISTS.                          
!                                                                       
      REAL L,M2 
      LOGICAL OK 
      DIMENSION P(8) 
      DATA HM/1.2648376/ 
                                                                        
      OK = .TRUE. 
      H1 = X+L 
      H2 = X+R 
      H3 = R+L 
      H4 = H1*H1+HM/2.*(H1*H1+H2*H2+H3*H3-4.) 
      IF (H4.LT.0.) GOTO 3 
      H = (H1+SQRT(H4))/HM 
!        goto 4                                                         
                                                                        
      IF (X.GT.-(L+R+2.*H)/2.) GOTO 3 
      C1 = 2.*R+X+L 
      C2 = X-L 
      D = -(L+X+2.*H) 
      H1 = C1*C1 
      H2 = C2*C2 
      H3 = D*D 
      A2 = -(2.*H3+H1+H2)/4. 
      A1 = -D/4.*(H1-H2) 
        if(QU.lt.0.)A1=-A1 
      A0 = (H3-H1)*(H3-H2)/16. 
      M2 = -(A2+2.)/10. 
      IF (M2.LT.1.E-8) GOTO 3 
      DO IETA = 1,17 
       IF (IETA.GT.1) GOTO 7 
       ETA = 1.E-3 
       GOTO 8 
    7  IF (IETA.GT.8) GOTO 9 
       ETA = FLOAT(IETA-1)/10. 
       GOTO 8 
    9  IF (IETA.GT.12) GOTO 10 
       ETA = FLOAT(IETA+6)/20. 
       GOTO 8 
   10  ETA = FLOAT(IETA+33)/50. 
    8  ETA2 = ETA*ETA 
       H1 = 1. + ETA2/3 
       H2 = SQRT(H1)*A1/8./M2+2. 
       SINT2 = ((A0-9.*M2*M2+2.*M2*(5.-ETA2)/H1-1.)/4./M2*H1             &
                                              +2.*H2)/(9.-ETA2)
!       write(6,'(a,f12.3)')' SINT2=', SINT2
       IF (ABS(SINT2) .LT. 1.E-3) GOTO 4 
       IF (SINT2.LT.0.) GOTO 5 
       IF (SINT2.GT.1.) GOTO 5 
       COS2P = (3.-H2/SINT2)/ETA 
       IF (ABS(COS2P) .LE.1.) GOTO 4 
    5 continue
      END DO 
      GOTO 3 
    4 continue
      P(1)=L 
      P(2)=X 
      P(3)=-(2.*H+R+L+X) 
      P(4)=2.*H+X 
      P(5)=-(R+L+X) 
      P(6)=R 
      P(7)=R-2.*H 
      P(8)=2.*H+L 
      RETURN 
    3 OK = .FALSE. 
      RETURN 
      END                                           
!                                                                       
!                                                                       
      SUBROUTINE PLOT3 
!                                                                       
!	PLOTS THE POSSIBLE LINE POSITIONS AFTER INDEXING. (FOR IRON           
!	SPECTRA OF MAGNETIC SPLITTING.)                                       
!                                                                       
!	X- AND Y- COORDINATES ARE CHANGED FOR BENSON-SOFTWARE                 
!                                                                       
      REAL L 
      DIMENSION F(8), G(8), NUM(8), LIST(1) 
      COMMON/LINE/ A(8,201), N1, N2, L, R, XM, YM, xbeg, ybeg 
!	DATA NUM /1H1,1H2,1H3,1H4,1H5,1H6,1H7,1H8/                            
        do i=1,8 
         NUM(i)=i 
        end do 
!        save                                                           
      NN=N2-N1+1 
      TX2= XM/2. 
      TX = XM/(R-L) 
      TY = YM/FLOAT(NN-1) 
!us	CALL IBENA(IBUF,0,1)                                                
      IF ( NN.EQ.1 ) GO TO 6 
      DO 14 J=1,8 
!	X = XM - ((A(J,N1) - L)*TX)                                           
        X=xbeg+(A(J,N1) - L)*TX 
      CALL XMOV (YM+ybeg,X) 
      F(J) = X 
      DO I = N1,N2 
!	X = XM - ((A(J,I) - L)*TX)                                            
        X=xbeg+(A(J,I) - L)*TX 
      Y = ybeg+YM - (TY*FLOAT(I-N1)) 
      if(J.eq.1.or.J.eq.6) then 
         call XDRAW(-2000,Y,X) 
        else if(J.eq.2) then 
         CALL XDRAW(-3000,Y,X) 
        else 
         CALL XDRAW(0,Y,X) 
        end if 
      end do 
   14 G(J) = X 
      GOTO 8 
    6 DO J=1,8 
       X = xbeg+XM - ((A(J,N1)-L)*TX) 
       CALL XMOV(YM+ybeg,X) 
       CALL XDRAW(0,0.,X) 
       F(J) = X 
       G(J) = X
      end do 
    8 Y = ybeg+YM-0.03 
      DO I = 1,8 
       X = F(I) 
       LIST(1) = NUM(I) 
        write(3,'(4f10.2,a,i1)')X,Y,0.3,0.3,';',NUM(I) 
!	CALL TXTPLO (Y,X,0,LIST,1,0.3,0.3,0.,-1.0,xt,yt)                      
      END DO 
      Y = ybeg 
      DO I = 1,8 
       X = G(I) 
       LIST(1) = NUM(I) 
       write(3,'(4f10.2,a,i1)')X,Y,0.3,0.3,';',NUM(I) 
!	CALL TXTPLO (Y,X,0,LIST,1,0.3,0.3,0.,-1.0,xt,yt)                      
      END DO 
 1000  RETURN 
      END                                           
                                                                        
        subroutine XMOV(YM,X) 
        write(2,'(i3,2f12.3)') 34, X,YM 
        return 
      END                                           
        subroutine XDRAW(icol,YM,X) 
        write(2,'(i6,2f12.3)') icol, X,YM 
        return 
      END                                           
                                                                        
       subroutine lines_L_H(QAS,eta,Is,L1,L2,L6,ioct,                   &
                           haeu,Phi_H,Teta_H,b_exist)                  
                                                                        
       real Is,L1,L2,L6,amuea,amueg,cTms,arcos 
       logical b_exist 
       parameter (cTms=15.2502,amuea= -0.15531, amueg=0.090604) 
                                                                        
!      Fe_kGm/mm/s = 15.2502      6                                     
!      #ground state J(Fe)=1/2, exited state J(Fe)=3/2                  
!      Fe_jg = 0.5                7                                     
!      Fe_je = 1.5                8                                     
!      #  magnetic moments / nuclear magneton ( mue_n)                  
!      Fe_mueg = 0.090604         9                                     
!      Fe_muee = -0.15531         10                                    
                                                                        
       nwr=6 
!      if eta<0 the theoretical spectrum with haeu=0 (zero magnetic     
!                                        field is calculated)           
      pi     = atan(1.)*4. 
      rad=pi/180. 
      beta = 10.0/9.0*(amuea/amueg)**2-2.0 
      aL1 = L1-IS 
      aL2 = L2-IS 
      aL6 = L6-IS 
      hh = (aL1+aL2)**2 + (aL2+aL6)**2 + (aL1+aL6)**2 - QAS**2 
      h = hh*beta/2.0 + (aL2+aL1)**2 
      IF (h.lt.0.0) then 
!        write(nwr,'(3(a,f8.3,/),a,/)')                                 
!     &' h = (aL1+aL2)**2 + (aL2+aL6)**2 + (aL1+aL6)**2 - QAS**2 =',hh, 
!     &' beta/2.     =',beta/2.0,                                       
!     &' (aL2+aL1)**2=',(aL1+aL2)**2,                                   
!     &' h*beta/2.0 + (aL2+aL1)**2=',h,' is not > 0.!'                  
        goto 999 
      end if 
      h = (sqrt(h) + (aL1+aL2))/beta 
                                                                        
      haeu = h*cTms/amueg 
                                                                        
      QUAD =abs(QAS/2.) 
      h = h/QUAD 
      X = aL2/QUAD 
      aL= aL1/QUAD 
      R = aL6/QUAD 
                                                                        
      h1 = X+aL 
      h2 = X+R 
      h3 = R+aL 
      h0 = -(h3+2.0*h)/2.0 
      IF (X.gt.h0) then 
!        write(nwr,'(2(a,f8.3,/),a,/)')                                 
!     &'            X=aL2/abs(QAS/2)  =',X,                             
!     &' h0=-(aL6+aL1+h)/abs(QAS/4.)  =',h0,                            
!     &' X is not < h0 !'                                               
        goto 999 
      end if 
      c1 = 2.0*R+h1 
      c2 = X-aL 
      d  = -(h1+2.0*h) 
      h1 = c1**2 
      h2 = c2**2 
      h3 = d**2 
      a2 = -(2.0*h3+h1+h2)/4.0 
      a1 = -d/4.0*(h1-h2) 
       if (QAS.lt.0.0) a1=-a1 
      a0 = (h3-h1)*(h3-h2)/16.0 
                                                                        
      am2 = -(a2+2.0)/10.0 
      IF (am2.lt.0.00001) then 
!        write(nwr,'(a,f8.3,a,/)')                                      
!     &' am2=-(a2++2)/10 =',am2,' is < 0.00001 '                        
        goto 999 
      end if 
      eta2 = eta**2 
      h1 = 1.0+eta2/3.0 
      h2 = sqrt(h1)*a1/8.0/am2+2.0 
                                                                        
        sint2 = ((a0-9.0*am2*am2+2.0*am2*(5.0-eta2)/h1-1.0)             &
     &        /4.0/am2*h1+2.0*h2)/(9.0-eta2)                            
        if (sint2.lt.0.0.or.sint2.gt.1.) then 
!         write(nwr,'(a,f8.3,a,/)')                                     
!     &' sin(theta)**2 =',sint2,'  < 0.0 '                              
        goto 999 
        end if 
        if (sint2.lt.0.00001.or.eta.lt.0.0001) then 
          cos2p = 1. 
        else 
          cos2p = (3.0-h2/sint2)/eta 
          if (abs(cos2p).gt.1.0) then 
!           write(nwr,'(a,f8.3,a,/)')                                   
!     &     ' cos(2*phi) =',cos2p,' is out of range  '                  
           goto 999 
          end if 
        end if 
                                                                        
       teta=arcos(sqrt(1.-sint2)) 
       phi =arcos(cos2p)/2. 
                                                                        
        if(ioct.gt.4) then 
         teta=pi-teta 
         i_oct=ioct-4 
        else 
         i_oct=ioct 
        end if 
                                                                        
      goto(101,102,103,104) i_oct 
  101 Phi_H  = phi 
      Teta_H = teta 
      goto 105 
  102 Phi_H  = pi-phi 
      Teta_H = teta 
      goto 105 
  103 Phi_H  = pi+phi 
      Teta_H = teta 
      goto 105 
  104 Phi_H  = -phi 
      Teta_H = teta 
      goto 105 
  105 continue 
      b_exist=.true. 
  999 continue 
                                                                        
      return 
      END                                           
                                                                        
      real function arcos(h) 
                                                                        
      pi2=2.0*atan(1.0) 
      hh=h*h 
      if(hh.ge.1) then 
       arcos=0.0 
       if(h.lt.0.0) arcos=2.0*pi2 
      else 
       s=sqrt(1.0-hh) 
       if(abs(h).lt.0.0001) then 
        arcos=pi2 
       else 
        arcos=atan(s/h) 
        if(h.lt.0) arcos=2.0*pi2+arcos 
       end if 
      end if 
      return 
      END                                           
